<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Todd Riggins">
   <meta name="GENERATOR" content="Mozilla/4.61 [en] (Win98; I) [Netscape]">
   <title>EXOTICA: GRAPHICS</title>
</head>
<body background="images/exotica_bg.gif" bgcolor="#000000" text="#ffffff">
<center>
<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><center><b><font color="maroon"><font size=+2>
<a NAME="GRAPHICS"></a>EXOTICA: GRAPHICS
</font></font></b></center></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><center><b><font color="black">
Contents<br>
78 Routines<br>
+1 Euphoria only routine (CreateFont)<p>
<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Main DirectDraw Routines:<br>
<A href="e_dgraph.html#DDRAW_INIT">DDRAW_INIT</A><br>
<A href="e_dgraph.html#IS_DDRAW_VALID">IS_DDRAW_VALID</A><br>
<A href="e_dgraph.html#DDRAW_RELEASE">DDRAW_RELEASE</A><p>

Memory Routines:<br>
<A href="e_dgraph.html#GET_PRIM_SURFACE_MEM">GET_PRIM_SURFACE_MEM(v1.6)</A><br>
<A href="e_dgraph.html#TOTAL_VIDEO_MEMORY">TOTAL_VIDEO_MEMORY(v1.5)</A><br>
<A href="e_dgraph.html#AVAIL_VIDEO_MEMORY">AVAIL_VIDEO_MEMORY(v1.5)</A><br>
<A href="e_dgraph.html#TOTAL_TEXTURE_MEMORY">TOTAL_TEXTURE_MEMORY(v1.5)</A><br>
<A href="e_dgraph.html#AVAIL_TEXTURE_MEMORY">AVAIL_TEXTURE_MEMORY(v1.5)</A><p>

Video Mode Routines:<br>
<A href="e_dgraph.html#CFG_VIDEO_MODE">CFG_VIDEO_MODE(v1.5)</A><br>
<A href="e_dgraph.html#SET_VIDEO_MODE">SET_VIDEO_MODE</A><br>
<A href="e_dgraph.html#GET_VIDEO_MODE_DESC">GET_VIDEO_MODE_DESC</A><br>
<A href="e_dgraph.html#GET_NUMBER_OF_VIDEO_MODES">GET_NUMBER_OF_VIDEO_MODES(v1.5)</A><br>
<A href="e_dgraph.html#SWITCH_TO_VMODE">SWITCH_TO_VMODE</A><br>
<A href="e_dgraph.html#RESTORE_VMODE">RESTORE_VMODE</A><br>
<A href="e_dgraph.html#RESTORE_VIDEO_BITMAPS">RESTORE_VIDEO_BITMAPS</A><p>

Surface Specific Routines:<br>
<A href="e_dgraph.html#CLEAR_SURFACE">CLEAR_SURFACE</A><br>
<A href="e_dgraph.html#SURFACE_FLIP">SURFACE_FLIP</A><br>
<A href="e_dgraph.html#SURFACE_RECT_BLIT">SURFACE_RECT_BLIT</A><br>
<A href="e_dgraph.html#SURFACE_WIDTH">SURFACE_WIDTH</A><br>
<A href="e_dgraph.html#SURFACE_HEIGHT">SURFACE_HEIGHT</A><br>
<A href="e_dgraph.html#SURFACE_DEPTH">SURFACE_DEPTH</A><br>
<A href="e_dgraph.html#SURFACE_LOCK">SURFACE_LOCK</A><br>
<A href="e_dgraph.html#SURFACE_UNLOCK">SURFACE_UNLOCK</A><br>
<A href="e_dgraph.html#SURFACE_PITCH">SURFACE_PITCH</A><br>
<A href="e_dgraph.html#SURFACE_POINTER">SURFACE_POINTER</A><br>
<A href="e_dgraph.html#BPP">BPP</A><br>
<A href="e_dgraph.html#SAVE_BMP">SAVE_BMP(v1.5)</A><br>
<A href="e_dgraph.html#GET_SURFACE_PIXEL_FORMAT">GET_SURFACE_PIXEL_FORMAT(v1.5)</A><p>

Bitmap Surface Specific Routines:<br>
<A href="e_dgraph.html#CLEAR_BITMAP">CLEAR_BITMAP</A><br>
<A href="e_dgraph.html#SET_BITMAP_TRANS_COLOR">SET_BITMAP_TRANS_COLOR(v1.5)</A><br>
<A href="e_dgraph.html#SET_ALL_BITMAPS_TRANS_COLOR">SET_ALL_BITMAPS_TRANS_COLOR(v1.5)</A><br>
<A href="e_dgraph.html#BITMAP_RECT_BLIT">BITMAP_RECT_BLIT</A><br>
<A href="e_dgraph.html#SCROLL_BITMAP">SCROLL_BITMAP</A><br>
<A href="e_dgraph.html#BITMAP_WIDTH">BITMAP_WIDTH</A><br>
<A href="e_dgraph.html#BITMAP_HEIGHT">BITMAP_HEIGHT</A><br>
<A href="e_dgraph.html#BITMAP_LOCK">BITMAP_LOCK</A><br>
<A href="e_dgraph.html#BITMAP_UNLOCK">BITMAP_UNLOCK</A><br>
<A href="e_dgraph.html#BITMAP_PITCH">BITMAP_PITCH(v1.5)</A><br>
<A href="e_dgraph.html#BITMAP_POINTER">BITMAP_POINTER(v1.5)</A><p>

Primary Surface Specific Routines:<br>
<A href="e_dgraph.html#CLEAR_PRIM_SURFACE">CLEAR_PRIM_SURFACE(v1.5)</A><br>
<A href="e_dgraph.html#PRIM_SURFACE_LOCK">PRIM_SURFACE_LOCK(v1.5)</A><br>
<A href="e_dgraph.html#PRIM_SURFACE_UNLOCK">PRIM_SURFACE_UNLOCK(v1.5)</A><br>
<A href="e_dgraph.html#WAIT_FOR_VB">WAIT_FOR_VB(v1.5)</A><p>

Palette Pixel Value Routines:<br>
Note: use with 8bit depth modes only<br>
<A href="e_dgraph.html#LOAD_PALETTE">LOAD_PALETTE</A><br>
<A href="e_dgraph.html#SET_RGB_ENTRY">SET_RGB_ENTRY</A><br>
<A href="e_dgraph.html#SET_PALETTE">SET_PALETTE</A><br>
<A href="e_dgraph.html#SET_SYSTEM_PALETTE">SET_SYSTEM_PALETTE</A><br>
<A href="e_dgraph.html#PAL_PUT_PIXEL">PAL_PUT_PIXEL</A><br>
<A href="e_dgraph.html#PAL_GET_PIXEL">PAL_GET_PIXEL</A><br>
<A href="e_dgraph.html#BITMAP_PAL_PUT_PIXEL">BITMAP_PAL_PUT_PIXEL</A><p>

RGB Pixel Value Routines:<br>
Note: use with 16bit or higher<br>
depth modes only<br>
<A href="e_dgraph.html#RGB_PUT_PIXEL">RGB_PUT_PIXEL</A><br>
<A href="e_dgraph.html#RGB_GET_PIXEL">RGB_GET_PIXEL</A><br>
<A href="e_dgraph.html#GET_RED_VALUE">GET_RED_VALUE</A><br>
<A href="e_dgraph.html#GET_GREEN_VALUE">GET_GREEN_VALUE</A><br>
<A href="e_dgraph.html#GET_BLUE_VALUE">GET_BLUE_VALUE</A><br>
<A href="e_dgraph.html#MAKE_RGB">MAKE_RGB</A><br>
<A href="e_dgraph.html#BITMAP_RGB_PUT_PIXEL">BITMAP_RGB_PUT_PIXEL</A><p>

Main Bitmap Routines:<br>
<A href="e_dgraph.html#LOAD_BITMAP">LOAD_BITMAP</A><br>
<A href="e_dgraph.html#CREATE_BITMAP">CREATE_BITMAP</A><br>
<A href="e_dgraph.html#FREE_BITMAP">FREE_BITMAP</A><p>

Blit to Surface Routines:<br>
<A href="e_dgraph.html#BLIT_BITMAP">BLIT_BITMAP</A><br>
<A href="e_dgraph.html#TRANS_BLIT_BITMAP">TRANS_BLIT_BITMAP</A><br>
<A href="e_dgraph.html#BLITFAST">BLITFAST</A><br>
<A href="e_dgraph.html#TRANS_BLITFAST">TRANS_BLITFAST</A><br>
<A href="e_dgraph.html#RECT_BLITFAST">RECT_BLITFAST</A><br>
<A href="e_dgraph.html#TRANS_RECT_BLITFAST">TRANS_RECT_BLITFAST</A><p>

Blit to Bitmap Surface Routines:<br>
<A href="e_dgraph.html#BITMAP_BLIT_BITMAP">BITMAP_BLIT_BITMAP</A><br>
<A href="e_dgraph.html#TRANS_BITMAP_BLIT_BITMAP">TRANS_BITMAP_BLIT_BITMAP</A><br>
<A href="e_dgraph.html#BITMAP_BLITFAST">BITMAP_BLITFAST</A><br>
<A href="e_dgraph.html#TRANS_BITMAP_BLITFAST">TRANS_BITMAP_BLITFAST</A><br>
<A href="e_dgraph.html#BITMAP_RECT_BLITFAST">BITMAP_RECT_BLITFAST</A><br>
<A href="e_dgraph.html#TRANS_BITMAP_RECT_BLITFAST">TRANS_BITMAP_RECT_BLITFAST</A><p>

GDI Text Routines:<br>
<A href="e_dgraph.html#GDI_TEXTOUT">GDI_TEXTOUT</A><br>
<A href="e_dgraph.html#GDI_TEXTOUT_BITMAP">GDI_TEXTOUT_BITMAP</A><br>
<A href="e_dgraph.html#GDI_TEXTOUT_CENTER">GDI_TEXTOUT_CENTER</A><br>
<A href="e_dgraph.html#GDI_TEXTOUT_CENTER_BITMAP">GDI_TEXTOUT_CENTER_BITMAP</A><br>
<A href="e_dgraph.html#GDI_GET_CHARWIDTH">GDI_GET_CHARWIDTH</A><br>
<A href="e_dgraph.html#CreateFont">CreateFont</A><br>
<A href="e_dgraph.html#USE_FONT">USE_FONT</A><p>
</font></b></td></tr>
</table>
</font></b></center></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Main DirectDraw Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="DDRAW_INIT"></a><center><font color="Maroon">DDRAW_INIT</font></center>
<hr WIDTH="100%">
C: int DDRAW_INIT( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(DDRAW_INIT, {NULL}) <br>
<hr WIDTH="100%">
Description: Initializes DirectX's DirectDraw in order to do graphics. This routine 
shouldn't never fail. It would only fail if it wasn't able to detect an installed DirectX
version 7.0 or above. Exotica's edx.dll will only load and be usable if you have DirectX
version 7.0 or above. If you have a lower version, the dll will not be able to load because
it needs specific DirectX 7.0 functions to run which means that none of the Exotica's
routines will be executed.<br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="IS_DDRAW_VALID"></a><center><font color="Maroon">IS_DDRAW_VALID</font></center>
<hr WIDTH="100%">
C: int IS_DDRAW_VALID( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(IS_DDRAW_VALID,{NULL}) <br>
<hr WIDTH="100%">
Description: This routine detects if the DirectDraw was initialized. I use it in Exotica's
<i>emain</i> example file in the windproc function when detecting if the user alt-tab's out
of the program. I use it along with the RESTORE_VIDEO_BITMAPS routine.<br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="DDRAW_RELEASE"></a><center><font color="Maroon">DDRAW_RELEASE</font></center>
<hr WIDTH="100%">
C: int DDRAW_RELEASE( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(DDRAW_RELEASE,{NULL}) <br>
<hr WIDTH="100%">
Description: Frees DirectDraw from memory which was initialized with DDRAW_INIT.
Note: You don't have to call this routine. EXOTICA_EXIT will make sure DirectDraw is released. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Memory Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_PRIM_SURFACE_MEM"></a><center><font color="Maroon">GET_PRIM_SURFACE_MEM(v1.6)</font></center>
<hr WIDTH="100%">
C: int GET_PRIM_SURFACE_MEM( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_PRIM_SURFACE_MEM,{NULL}) <br>
<hr WIDTH="100%">
Description:<br>
Returns 0 if no memory availbale either in video memory or system memory to make primary surface.<br>
Returns 1 if primary surface resides in video memory.<br>
Returns 2 if primary surface resides in system memory.<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TOTAL_VIDEO_MEMORY"></a><center><font color="Maroon">TOTAL_VIDEO_MEMORY(v1.5)</font></center>
<hr WIDTH="100%">
C: DWORD TOTAL_VIDEO_MEMORY( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(TOTAL_VIDEO_MEMORY,{NULL}) <br>
<hr WIDTH="100%">
Description: Returns the total video memory your video card has.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="AVAIL_VIDEO_MEMORY"></a><center><font color="Maroon">AVAIL_VIDEO_MEMORY(v1.5)</font></center>
<hr WIDTH="100%">
C: DWORD AVAIL_VIDEO_MEMORY( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(AVAIL_VIDEO_MEMORY,{NULL}) <br>
<hr WIDTH="100%">
Description: Returns the available video memory your video card has left.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TOTAL_TEXTURE_MEMORY"></a><center><font color="Maroon">TOTAL_TEXTURE_MEMORY(v1.5)</font></center>
<hr WIDTH="100%">
C: DWORD TOTAL_TEXTURE_MEMORY( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(TOTAL_TEXTURE_MEMORY,{NULL}) <br>
<hr WIDTH="100%">
Description: Returns the total texture memory your video card has.
This one is a bit confusing for me. Expect better info in the future here.
On my video card( AGP Creative Banshee Voodoo2 ), it returns the same value
of video memory it has.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TOTAL_TEXTURE_MEMORY"></a><center><font color="Maroon">AVAIL_TEXTURE_MEMORY(v1.5)</font></center>
<hr WIDTH="100%">
C: DWORD AVAIL_TEXTURE_MEMORY( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(AVAIL_TEXTURE_MEMORY,{NULL}) <br>
<hr WIDTH="100%">
Description: Returns the available texture memory your video card has left.
This one is a bit confusing for me. Expect better info in the future here.
On my video card( AGP Creative Banshee Voodoo2 ), it returns the same value
of video memory it has.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Video Mode Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="CFG_VIDEO_MODE"></a><center><font color="Maroon">CFG_VIDEO_MODE(v1.5)</font></center>
<hr WIDTH="100%">
C: void CFG_VIDEO_MODE( DWORD BackBufferCount, int video_memory_mode ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(CFG_VIDEO_MODE, {BackBufferCount, video_memory_mode}) <br>
<hr WIDTH="100%">
Description: This routine must be called before the SET_VIDEO_MODE routine if you want to use it.
if you don't use it, Exotica will default to use double buffering and
will store the front and back surfaces into video memory if available, if not it will store the
two surfaces into software memory(RAM).<p>

Set the BackBufferCount to how many back buffers you want, memory given. Set it for 1 for double buffering
or set it to 2 for tripple buffering and so on. You can set it to a value of 0 if you want to blit
OpenGL graphics to the surface or graphic functions that you've created of your own. But, by
setting BackBufferCount to 0, you will not be able to use the majority of Exotica's graphic functions
to blit to the surface because those functions wants to blit to a back buffer. I have provided
some primary surface routines that will let you write to the primary surface and also clear the surface if you
have specified the BackBufferCount to 0. If you set this value lower than 0, it will default to 0.<p>

Set Vedio_Memory_Mode to 0 or 1.<br>
0 = Load primary and back buffer(s) into System memory.<br>
1 = Load primary and back buffer(s) into Video memory.<br>
Exotica defaults to 1.<br>
 
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <br>
<hr WIDTH="100%">
See Also: <A href="e_dgraph.html#MAKE_RGB">MAKE_RGB</A><p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_VIDEO_MODE"></a><center><font color="Maroon">SET_VIDEO_MODE</font></center>
<hr WIDTH="100%">
C: int SET_VIDEO_MODE( DWORD Width, DWORD Height, DWORD Depth ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SET_VIDEO_MODE, {Width, Height, Depth}) <br>
<hr WIDTH="100%">
Description: Sets the resolution and depth of the display screen to be viewed with.
The Depth here means how many colors can be displayed
at one time. Depths can be 8,16,24 or 32bit depending if your video
card can support those depths. Common DirectX screen resolutions are
640x480, 800x600, 1024x768 and common DirectX depths are 8 and 16bit.
Some videos cards can support other resolutions like 320x200, 640x400, 1280x1280 and so on.
Also, your video card may handle a certian screen resolution but your monitor may not be
able to support it. Some ideas to avoid this is to set the default video mode to
640x480 or have a windows setup dialoge box seperate from your program that allows
the user to select what video mode that he/she knows that they can use and then the setup
program can save a configuration file for your main program to load and use. <p>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_VIDEO_MODE_DESC"></a><center><font color="Maroon">GET_VIDEO_MODE_DESC</font></center>
<hr WIDTH="100%">
C: LPSTR GET_VIDEO_MODE_DESC( int incremented_variable )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_VIDEO_MODE_DESC,{incremented_variable})<br>
<hr WIDTH="100%">
Description: Returns the description of all available video modes supported by your 
video card. For example: 640x480x16 - means 640 screen width, 480 screen height and 16bit
depth. You must use this function in a loop to gather each mode available that your video card
supports, thats what the incremented_variable parameter is for. Also, check for 'empty' when
there is no more available video mode types detected, to stop trying to detect for more available
video modes when there is none left. Please look and examine how the <i>Setmode</i> example uses
this function to get a better understanding.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_NUMBER_OF_VIDEO_MODES"></a><center><font color="Maroon">GET_NUMBER_OF_VIDEO_MODES(v1.5)</font></center>
<hr WIDTH="100%">
C: int GET_NUMBER_OF_VIDEO_MODES( void )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_NUMBER_OF_VIDEO_MODES,{NULL})<br>
<hr WIDTH="100%">
Description: Returns the number of video modes that DirectX detects that your video card has.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SWITCH_TO_VMODE"></a><center><font color="Maroon">SWITCH_TO_VMODE</font></center>
<hr WIDTH="100%">
C: void SWITCH_TO_VMODE( int video_mode )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(SWITCH_TO_VMODE,{video_mode})<br>
<hr WIDTH="100%">
Description: Switch to a new video mode. The video_mode parameter specifies what video mode
you want. Example: After getting the list of video modes that are available with the GET_VIDEO_MODE_DESC,
enter the number in that list for the video_mode parameter. If, for example, you want to
switch to the 640x480x16 mode, and that mode was the 14th video mode detected by GET_VIDEO_MODE_DESC,
you would enter 14 as the video_mode parameter. Please look and examine how the <i>Setmode</i> example
uses this routine to get a better understanding.<br>
<hr WIDTH="100%">
Note: If you change to a lower depth, for example: 24bit to 16bit, you must reload your graphics because
when you change depths like that, the pixel information will get corrupted.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="RESTORE_VMODE"></a><center><font color="Maroon">RESTORE_VMODE</font></center>
<hr WIDTH="100%">
C: void RESTORE_VMODE( void )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(RESTORE_VMODE,{NULL})<br>
<hr WIDTH="100%">
Description: If for some reason the video mode you wanted to switch to leaves you with a 
black screen, most likely that means your monitor can't support that video mode even though
your video card does. The RESTORE_VMODE routine can be used to go back to the previous
working video mode that you were in. Please look and examine how the <i>Setmode</i> example
uses this routine to get a better understanding.<P>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="RESTORE_VIDEO_BITMAPS"></a><center><font color="Maroon">RESTORE_VIDEO_BITMAPS</font></center>
<hr WIDTH="100%"> 
C: void RESTORE_VIDEO_BITMAPS( void ) <br>
<hr WIDTH="100%"> 
Euphoria Procedure: c_proc(RESTORE_VIDEO_BITMAPS, {NULL}) <br>
<hr WIDTH="100%"> 
Description: This function is used in the wndproc function in the emain.ew file. When you have a fullscreen
DirectX program going displaying bitmaps that are stored in the video memory, a simple alt-tab
back to the desktop will corrupt the bitmap's video memory. Once you alt-tab back into a fullscreen
DirectX program, you need to restore the graphics to the original state.
RESTORE_VIDEO_BITMAPS magically does this for you. It remmebers the file location of the loaded
bitmaps that were stored in video memory and reloads them which restores them back to the original
graphic. If you had made your own bitmaps that were stored in video memory with the CREATE_BITMAP
routine, you will have to restore the graphics on your own. You can check the global atom aActive
to determine when you need to restore the graphics. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Surface Specific Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="CLEAR_SURFACE"></a><center><font color="Maroon">CLEAR_SURFACE</font></center>
<hr WIDTH="100%">
C: int CLEAR_SURFACE( DWORD Color_Value ) <br>  
<hr WIDTH="100%">
Euphoria Function: c_func(CLEAR_SURFACE, {Color_Value}) <br>  
<hr WIDTH="100%">
Description: CLEAR_SURFACE fills the surface with the specified color.
If you are in a depth mode of higher then 8bit, then you can use the MAKE_RGB()
routine to get return the color you want if you desire to clear the background
with a certain color. If you're in an 8bit depth mode, just enter the palette color
entry value you want. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <br>
<hr WIDTH="100%">
See Also: <A href="e_dgraph.html#MAKE_RGB">MAKE_RGB</A><br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_FLIP"></a><center><font color="Maroon">SURFACE_FLIP</font></center>
<hr WIDTH="100%">
C: void SURFACE_FLIP( void ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(SURFACE_FLIP, {NULL}) <br>
<hr WIDTH="100%">
Description: Currently, EXOTICA is designed around a double buffer system. You are actually blitting graphics, plotting pixels
and writting text with the GDI_TEXTOUT varients on to the back buffer. SURFACE_FLIP
will flip the back buffer to the front buffer which the viewer will see.
When the DirectX blitter has finished blitting what ever graphics you blitted
on the surface then the SURFACE_FLIP function will flip the buffers.
If the DirectX blitter hasn't finished drawing yet, SURFACE_FLIP will not be able to flip the
buffers until the DirectX blitter is finished. The SURFACE_FLIP  function will not stop the
flow of your program if it's waiting on the DirectX blitter to finish.
Anyways, I wouldn't even worry about this function. Just let it do it's job.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_RECT_BLIT"></a><center><font color="Maroon">SURFACE_RECT_BLIT</font></center>
<hr WIDTH="100%">
C: int SURFACE_RECT_BLIT( LPRECT Rectanglar_Region, DWORD Color ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SURFACE_RECT_BLIT, {Rectanglar_Region, Color}) <br>
<hr WIDTH="100%">
Description: Fills a rectanglar_region on the surface with the specified color. You must fill in a
rectanglar structure for this to work. The structure must be fall inside the width and height
of your surface that you specified using the SET_VIDEO_MODE function or you will get an error. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_WIDTH"></a><center><font color="Maroon">SURFACE_WIDTH</font></center>
<hr WIDTH="100%">
C: DWORD SURFACE_WIDTH( void )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(SURFACE_WIDTH,{NULL})<br>
<hr WIDTH="100%">
Description: Returns the current surface( Screen ) width. For example: If you have a
640x480x16 screen, it will return a value of 640.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_HEIGHT"></a><center><font color="Maroon">SURFACE_HEIGHT</font></center>
<hr WIDTH="100%">
C: DWORD SURFACE_HEIGHT( void )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(SURFACE_HEIGHT,{NULL})<br>
<hr WIDTH="100%">
Description: Returns the current surface( Screen ) height. For example: If you have a
640x480x16 screen, it will return a value of 480.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_DEPTH"></a><center><font color="Maroon">SURFACE_DEPTH</font></center>
<hr WIDTH="100%">
C: DWORD SURFACE_DEPTH( void )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(SURFACE_DEPTH,{NULL})<br>
<hr WIDTH="100%">
Description: Returns the current surface( Screen ) depth. For example: If you have a
640x480x16 screen, it will return a value of 16.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_LOCK"></a><center><font color="Maroon">SURFACE_LOCK</font></center>
<hr WIDTH="100%">
C: int SURFACE_LOCK( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SURFACE_LOCK, {NULL}) <br>
<hr WIDTH="100%">
Description: Must call this function before you attempt to write to the surface and/or
before using the PAL_PUT_PIXEL and RGB_PUT_PIXEL routines. <p>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_UNLOCK"></a><center><font color="Maroon">SURFACE_UNLOCK</font></center>
<hr WIDTH="100%">
C: int SURFACE_UNLOCK( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SURFACE_UNLOCK, {NULL}) <br>
<hr WIDTH="100%">
Description: Must call this function after you plot pixels with to the surface and/or
after using the PAL_PUT_PIXEL and RGB_PUT_PIXEL routines.
Remmeber, you can just use SURFACE_LOCK and SURFACE_UNLOCK 
once during the main program loop. The more SURFACE_LOCK and SURFACE_UNLOCK
routines you use, the slower the program will execute. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_PITCH"></a><center><font color="Maroon">SURFACE_PITCH</font></center>
<hr WIDTH="100%">
C: LONG SURFACE_PITCH( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SURFACE_PITCH,{NULL}) <br>
<hr WIDTH="100%">
Description: Returns the DirectX surface pitch.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SURFACE_POINTER"></a><center><font color="Maroon">SURFACE_POINTER</font></center>
<hr WIDTH="100%">
C: LPBYTE SURFACE_POINTER( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SURFACE_POINTER,{NULL}) <br>
<hr WIDTH="100%">
Description: Returns a pointer to the DirectX back buffer surface. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BPP"></a><center><font color="Maroon">BPP</font></center>
<hr WIDTH="100%">
C: DWORD BPP( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(BPP,{NULL}) <br>
<hr WIDTH="100%">
Description: Returns Bytes Per Pixel according to the Depth of the surface.
This function most likely isn't needed but here for my simplicities.<p>
<hr WIDTH="100%">
Return Values:<br>
&nbsp; 1 = 1 Byte Per Pixel = 8bit<br>
&nbsp; 2 = 2 Bytes Per Pixel = 16bit<br>
&nbsp; 3 = 3 Bytes Per Pixel = 24bit<br>
&nbsp; 4 = 4 Bytes Per Pixel = 32bit<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SAVE_BMP"></a><center><font color="Maroon">SAVE_BMP(v1.5)</font></center>
<hr WIDTH="100%">
C: int SAVE_BMP( LPSTR filename )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(SAVE_BMP,{filename}) <br>
<hr WIDTH="100%">
Description: Saves the surface to a bitmap specified by the filename. It will save
an 8bit bitmap if you are currently in an 8bit depth mode. If you are in a higher
depth mode, it will save the bitmap as a 24bit bitmap.<br>
<hr WIDTH="100%">
Return Values:<br>
&nbsp; 0 = succeeded<br>
&nbsp; 1 = failed<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_SURFACE_PIXEL_FORMAT"></a><center><font color="Maroon">GET_SURFACE_PIXEL_FORMAT(v1.5)</font></center>
<hr WIDTH="100%">
C: int GET_SURFACE_PIXEL_FORMAT( void )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_SURFACE_PIXEL_FORMAT,{NULL}) <br>
<hr WIDTH="100%">
Description: This function returns the current pixel format of the surfaces. Basically, this
function is only useful for 16bit mode. If you are writing to the surface with your own
graphic routines, then in 16bit mode you want to know if the user is using the
565 format or 555 format. The 555 format is actaully a 15bit vedio depth mode. But, in
DirectX terms, its a format of a the 16bit depth mode. Got it? Good. Anyways, the 565 and
the 555 formats produces different green values and that's why this function can
come in handy. <br>
<hr WIDTH="100%">
Return Values:<br>
&nbsp; 0 = succeeded<br>
&nbsp; 1 = failed<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Bitmap Surface Specific Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="CLEAR_BITMAP"></a><center><font color="Maroon">CLEAR_BITMAP</font></center>
<hr WIDTH="100%">
C: int CLEAR_BITMAP( int Bitmap_ID, DWORD Color_Value ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(CLEAR_BITMAP,{Bitmap_ID, Color_Value}) <br>
<hr WIDTH="100%">
Description: This routine is like the CLEAR_SURFACE routine except it clears the specified bitmap
to the specified color. If you are in a depth mode of higher then 8bit, then you can use the MAKE_RGB()
routine to get return the color you want if you desire to clear the background
with a certain color. If you're in an 8bit depth mode, just enter the palette color
entry value you want. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <br>
<hr WIDTH="100%">
See Also: <A href="e_dgraph.html#MAKE_RGB">MAKE_RGB</A><br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_BITMAP_TRANS_COLOR"></a><center><font color="Maroon">SET_BITMAP_TRANS_COLOR(v1.5)</font></center>
<hr WIDTH="100%">
C: void SET_BITMAP_TRANS_COLOR( int Bitmap_id, DWORD Color )
<hr WIDTH="100%">
Euphoria Procedure: c_proc(SET_BITMAP_TRANS_COLOR,{ Bitmap_ID, Color}) <br>
<hr WIDTH="100%">
Description: Set the specified bitmap with a certain transparency Color value. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_ALL_BITMAPS_TRANS_COLOR"></a><center><font color="Maroon">SET_ALL_BITMAPS_TRANS_COLOR(v1.5)</font></center>
<hr WIDTH="100%">
C: void SET_ALL_BITMAPS_TRANS_COLOR( DWORD Color )
<hr WIDTH="100%">
Euphoria Function: c_proc(SET_ALL_BITMAPS_TRANS_COLOR,{Color}) <br>
<hr WIDTH="100%">
Description: Set all bitmaps currently loaded/created with a certain transparency Color value. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_RECT_BLIT"></a><center><font color="Maroon">BITMAP_RECT_BLIT</font></center>
<hr WIDTH="100%">
C: int BITMAP_RECT_BLIT( int Bitmap_ID, LPRECT Rectanglar_Region, DWORD Color ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_RECT_BLIT,{ Bitmap_ID, Rectanglar_Region, Color}) <br>
<hr WIDTH="100%">
Description: Same rules like the SURFACE_RECT_BLIT except this function draws a rectanglar region
on a specified Bitmap. Bitmap_ID must be a valid bitmap. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success<br> 
&nbsp; 1 = failure<p> 
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SCROLL_BITMAP"></a><center><font color="Maroon">SCROLL_BITMAP</font></center>
<hr WIDTH="100%">
C: int SCROLL_BITMAP( int Bitmap_ID, DWORD X, DWORD Y, DWORD width, DWORD height, unsigned int Direction_X, unsigned int Direction_Y ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SCROLL_BITMAP,{Bitmap_ID, X, Y, width, height, Direction_X, Direction_Y}) <br>
<hr WIDTH="100%">
Description: Scroll a portion of a bitmap. This routine can only be used on specified bitmaps. The Direction_X and Direction_Y parameters can be a
positive or negative number which will move the area of the bitmap that many pixels. Look at the txtscroll.exw 
example code for an example of use. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_WIDTH"></a><center><font color="Maroon">BITMAP_WIDTH</font></center>
<hr WIDTH="100%">
C: LONG BITMAP_WIDTH( int Bitmap_ID ) <br>  
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_WIDTH,{Bitmap_ID}) <br>  
<hr WIDTH="100%">
Description: Returns a specified bitmap width. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_HEIGHT"></a><center><font color="Maroon">BITMAP_HEIGHT</font></center>
<hr WIDTH="100%">
C: LONG BITMAP_HEIGHT( int Bitmap_ID ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_HEIGHT,{Bitmap_ID}) <br>
<hr WIDTH="100%">
Description: Returns a specified bitmap height.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_LOCK"></a><center><font color="Maroon">BITMAP_LOCK</font></center>
<hr WIDTH="100%">
C: int BITMAP_LOCK( int bitmap_id )
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_LOCK, {bitmap_id}) <br>
<hr WIDTH="100%">
Description: Must call this function before you attempt to write to the bitmap's surface and/or
before using the BITMAP_PAL_PUT_PIXEL and BITMAP_RGB_PUT_PIXEL routines.
The bitmap_id parameter specifies what bitmap you want to lock. <p>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_UNLOCK"></a><center><font color="Maroon">BITMAP_UNLOCK</font></center>
<hr WIDTH="100%">
C: int BITMAP_UNLOCK( int bitmap_id )
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_UNLOCK, {bitmap_id}) <br>
<hr WIDTH="100%">
Description: Must call this function after you plot pixels with the bitmap's surface and/or
after using the BITMAP_PAL_PUT_PIXEL and BITMAP_RGB_PUT_PIXEL routines.
Remmeber, you can just use BITMAP_LOCK and BITMAP_UNLOCK 
once during the main program loop. The more BITMAP_LOCK and BITMAP_UNLOCK
routines you use, the slower the program will execute.
The bitmap_id parameter specifies what bitmap you want to unlock. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_PITCH"></a><center><font color="Maroon">BITMAP_PITCH</font></center>
<hr WIDTH="100%">
C: LONG BITMAP_PITCH( int bitmap_id )
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_PITCH, {bitmap_id}) <br>
<hr WIDTH="100%">
Description: Returns the pitch value for the specified bitmap.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_POINTER"></a><center><font color="Maroon">BITMAP_POINTER</font></center>
<hr WIDTH="100%">
C: LPBYTE BITMAP_POINTER( int bitmap_id )
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_POINTER, {bitmap_id}) <br>
<hr WIDTH="100%">
Description: Returns the pointer to the specified bitmap surface.<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Primary Surface Specific Routines:<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="CLEAR_PRIM_SURFACE"></a><center><font color="Maroon">CLEAR_PRIM_SURFACE</font></center>
<hr WIDTH="100%">
C: int CLEAR_PRIM_SURFACE( DWORD Color )
<hr WIDTH="100%">
Euphoria Function: c_func(CLEAR_PRIM_SURFACE, {Color}) <br>
<hr WIDTH="100%">
[Note: This routine is intended for use with a non-multi-buffered method.]<br>
Description: CLEAR_PRIM_SURFACE fills the primary surface with the specified color.
If you are in a depth mode of higher then 8bit, then you can use the MAKE_RGB()
routine to get return the color you want if you desire to clear the background
with a certain color. If you're in an 8bit depth mode, just enter the palette color
entry value you want. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <br>
<hr WIDTH="100%">
See Also: <A href="e_dgraph.html#MAKE_RGB">MAKE_RGB</A><br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="PRIM_SURFACE_LOCK"></a><center><font color="Maroon">PRIM_SURFACE_LOCK</font></center>
<hr WIDTH="100%">
C: int PRIM_SURFACE_LOCK( void )
<hr WIDTH="100%">
Euphoria Function: c_func(PRIM_SURFACE_LOCK, {NULL}) <br>
<hr WIDTH="100%">
[Note: This routine is intended for use with a non-multi-buffered method.]<br>
Description: Must call this function before you attempt to write to the primary surface<p>
To write to the primary surface, it's okay to use the SURFACE_POINTER and SURFACE_PITCH
functions.<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="PRIM_SURFACE_UNLOCK"></a><center><font color="Maroon">PRIM_SURFACE_UNLOCK</font></center>
<hr WIDTH="100%">
C: int PRIM_SURFACE_UNLOCK( void )
<hr WIDTH="100%">
Euphoria Function: c_func(PRIM_SURFACE_UNLOCK, {NULL}) <br>
<hr WIDTH="100%">
[Note: This routine is intended for use with a non-multi-buffered method.]<br>
Description: Must call this function after you write to the primary surface<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="WAIT_FOR_VB"></a><center><font color="Maroon">WAIT_FOR_VB</font></center>
<hr WIDTH="100%">
C: void WAIT_FOR_VB( int flag )
<hr WIDTH="100%">
Euphoria Procedure: c_proc(WAIT_FOR_VB, {flag}) <br>
<hr WIDTH="100%">
[Note: This routine is intended for use with a non-multi-buffered method.]<br>
Description: This routine helps the application synchronize itself with the vertical-blank interval.
Set the flag parameter to 0 or 1 to determine how long to wait for the vertical blank.<p>
One of the following flags:<p>
0 = Returns when the vertical-blank interval ends and the display begins. <br>
1 = Returns when the vertical-blank interval begins. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Palette Pixel Value Routines:<br>
Note: use with 8bit depth modes only<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="LOAD_PALETTE"></a><center><font color="Maroon">LOAD_PALETTE</font></center>
<hr WIDTH="100%">
C: int LOAD_PALETTE( LPSTR Bitmap_Filename ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(LOAD_PALETTE, { Bitmap_Filename }) <br>
<hr WIDTH="100%">
Description: Loads a palette from a bitmap. Be careful here. If you load
in a bunch of bitmaps to be used together, make sure they were made with the same
palette. Otherwise, the colors will look all screwy. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
<hr WIDTH="100%">
Euphoria Example: <br>
&nbsp; atom edx1 <br>
&nbsp; edx1 = allocate_string("bmp/exotica.bmp") <br><br>
&nbsp; funcval=c_func(LOAD_PALETTE, {edx1})<br> 
&nbsp; if funcval !=0 then return 1 end if <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_RGB_ENTRY"></a><center><font color="Maroon">SET_RGB_ENTRY</font></center>
<hr WIDTH="100%">
C: int SET_RGB_ENTRY( int Palette_Entry, int Red_Value, int Green_Value, int Blue_Value ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SET_RGB_ENTRY, { Palette_Entry, Red_Value, Green_Value, Blue_Value}) <br>
<hr WIDTH="100%">
Description: This is only for an 8bit Depth programs using a palette of 256 colors. The Palette_Entry
is a value between 1-256 (Wierd ain't it?) and the Red, Green, Blue Values
have a value between 0-255. Note: I wouldn't use this function to make palette manipulation
effects. It will slow your program down alot if you try. Try it. <p>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_PALETTE"></a><center><font color="Maroon">SET_PALETTE</font></center>
<hr WIDTH="100%">
C: int SET_PALETTE( PALETTEENTRY Palette[256] ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(SET_PALETTE,{ Palette }) <br>
<hr WIDTH="100%">
Description: This is only for an 8bit Depth programs using a palette of 256 colors. This is the
function you may want to do palette manipulation with. The 'Palette' parameter
holds a sequence of RGB triplets. Please, check out the <i>RGB_Pal</i> example
code to get a good understanding and a better example of this routine. <p>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="SET_SYSTEM_PALETTE"></a><center><font color="Maroon">SET_SYSTEM_PALETTE</font></center>
<hr WIDTH="100%">
C: void SET_SYSTEM_PALETTE( void ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(SET_SYSTEM_PALETTE,{NULL}) <br>
<hr WIDTH="100%">
Description: Use this routine if you are not concerned with the palette. This routine
sets the palette to the current Windows palette. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="PAL_PUT_PIXEL"></a><center><font color="Maroon">PAL_PUT_PIXEL</font></center>
<hr WIDTH="100%">
C: void PAL_PUT_PIXEL( DWORD X, DWORD Y, DWORD Palette_Color )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(PAL_PUT_PIXEL, {X, Y, Palette_Color})<br>
<hr WIDTH="100%">
Description: This routine is for 8bit depth use only. This plots a pixel at the X, Y 
location on the surface with the specified Palette_Color.  You must call the SURFACE_LOCK function
before attempting to plot pixels onto the surface. Then you must call the SURFACE_UNLOCK
function after you are done plotting the pixels. <br>
<hr WIDTH="100%">
Euphoria Example:<br>
&nbsp; funcval = c_func( SURFACE_LOCK, {NULL}) <p>
&nbsp; -- draw a horizontal line <br>
&nbsp; for h = 1 to 20 do <br>
&nbsp; &nbsp; c_proc( PAL_PUT_PIXEL, {40+h, 40, 1}) <br>
&nbsp; end for <p>  
&nbsp; -- draw a vertical line <br>
&nbsp; for v = 1 to 20 do <br>
&nbsp;&nbsp; c_proc( PAL_PUT_PIXEL, {40, 40+v, 1}) <br>
&nbsp; end for <p>
&nbsp; -- draw a diagonal line<br>
&nbsp; for d = 1 to 20 do<br>
&nbsp;&nbsp; c_proc( PAL_PUT_PIXEL,{40+d, 40+d, 1})<br>
&nbsp; end for <p>
&nbsp; funcval = c_func( SURFACE_UNLOCK, {NULL}) <br>
<hr WIDTH="100%">
See also SURFACE_LOCK(), SURFACE_UNLOCK() <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="PAL_GET_PIXEL"></a><center><font color="Maroon">PAL_GET_PIXEL</font></center>
<hr WIDTH="100%">
C: DWORD PAL_GET_PIXEL( DWORD X, DWORD Y )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(PAL_GET_PIXEL, {X, Y})<br>
<hr WIDTH="100%">
Description: This routine is for 8bit depth use only. Returns the palette color value from
the specified X, Y location of the surface.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_PAL_PUT_PIXEL"></a><center><font color="Maroon">BITMAP_PAL_PUT_PIXEL</font></center>
<hr WIDTH="100%">
C: void BITMAP_PAL_PUT_PIXEL( int Bitmap_ID, DWORD X, DWORD Y, DWORD Palette_Color )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(BITMAP_PAL_PUT_PIXEL,{Bitmap_ID, X, Y, Palette_Color})<br>
<hr WIDTH="100%">
Description: Same as the PAL_PUT_PIXEL routine except you plot a pixel on to a specified bitmap. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
RGB Pixel Value Routines:<br>
Note: use with 16bit or higher<br>
depth modes only<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="RGB_PUT_PIXEL"></a><center><font color="Maroon">RGB_PUT_PIXEL</font></center>
<hr WIDTH="100%">
C: void RGB_PUT_PIXEL( DWORD X, DWORD Y, int Red, int Green, int Blue )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(RGB_PUT_PIXEL,{X, Y, Red, Green, Blue})<br>
<hr WIDTH="100%">
Description: This routine is for 16bit and higher depths use only. This plots a pixel at the X, Y 
location on the surface with the specified Red, Green, Blue values.  You must call the SURFACE_LOCK
function before attempting to plot pixels onto the surface. Then you must call the SURFACE_UNLOCK
function after you are done plotting the pixels. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="RGB_GET_PIXEL"></a><center><font color="Maroon">RGB_GET_PIXEL</font></center>
<hr WIDTH="100%">
C: DWORD RGB_GET_PIXEL( DWORD X, DWORD Y )<br> 
<hr WIDTH="100%">
Euphoria Function: c_func(RGB_GET_PIXEL, {X, Y})<br> 
<hr WIDTH="100%">
Description: This routine is for 16bit and higher depths use only. Returns the actual color value from
the specified X, Y location of the surface.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_RED_VALUE"></a><center><font color="Maroon">GET_RED_VALUE</font></center>
<hr WIDTH="100%"> 
C: UCHAR GET_RED_VALUE( LONG Color_Value ) <br>
<hr WIDTH="100%"> 
Euphoria Function: c_func(GET_RED_VALUE,{Color_Value}) <br>
<hr WIDTH="100%"> 
Description: Returns the Red Value from the return value from the
RGB_GET_PIXEL routine. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_GREEN_VALUE"></a><center><font color="Maroon">GET_GREEN_VALUE</font></center>
<hr WIDTH="100%">
C: UCHAR GET_GREEN_VALUE( LONG Color_Value ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_GREEN_VALUE,{Color_Value}) <br>
<hr WIDTH="100%">
Description: Returns the Green Value from the return value from the
RGB_GET_PIXEL routine. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_BLUE_VALUE"></a><center><font color="Maroon">GET_BLUE_VALUE</font></center>
<hr WIDTH="100%">
C: UCHAR GET_BLUE_VALUE( LONG Color_Value ) <br>  
<hr WIDTH="100%">
Function: c_func(GET_BLUE_VALUE,{Color_Value}) <br>  
<hr WIDTH="100%">
Description: Returns the Blue Value from the return value from the
RGB_GET_PIXEL routine. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="MAKE_RGB"></a><center><font color="Maroon">MAKE_RGB</font></center>
<hr WIDTH="100%">
C: DWORD MAKE_RGB( int Red, int Green, int Blue )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(MAKE_RGB,{Red, Green, Blue})<br>
<hr WIDTH="100%">
Description: When you are using a screen depth of 16, 24 or 32bit, you can use the MAKE_RGB routine for the color value
for the routines that have a color parameter. The Red, Green and Blue parameters accept a color range between
0-255. Note: the color that you want may not be the color that gets displayed if you are using a 16bit depth.
That's because 16bit depth has less colors that can be displayed at once than 24 and 32 bit depths. But this function
will pick the closest color to be displayed. This function is not meant to be used with 8bit depth.<br>
<hr WIDTH="100%">
Return Value:<br>
&nbsp; Returns the 24bit color value made by the MAKE_RGB routine.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_RGB_PUT_PIXEL"></a><center><font color="Maroon">BITMAP_RGB_PUT_PIXEL</font></center>
<hr WIDTH="100%">
C: void BITMAP_RGB_PUT_PIXEL( int Bitmap_ID, DWORD X, DWORD Y, int Red, int Green, int Blue )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(BITMAP_RGB_PUT_PIXEL,{Bitmap_ID, X, Y, Red, Green, Blue})<br>
<hr WIDTH="100%">
Description: Same as the RGB_PUT_PIXEL routine except you plot a pixel on to a specified bitmap. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Main Bitmap Routines:<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="LOAD_BITMAP"></a><center><font color="Maroon">LOAD_BITMAP</font></center>
<hr WIDTH="100%">
C: int LOAD_BITMAP( LPSTR filename, int Bitmap_ID, int Memory_Mode}) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(LOAD_BITMAP, { filename, Bitmap_ID, Memory_Mode}) <br>
<hr WIDTH="100%">
Description: Load a *.bmp file into the specified memory. Set the Memory_Mode
parameter to 1 = created in video memory or 0 = created in software memory. <p>
<hr WIDTH="100%">
Return Value: 
&nbsp; 0 = success<br> 
&nbsp; 1 = failure<p> 
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="CREATE_BITMAP"></a><center><font color="Maroon">CREATE_BITMAP</font></center>
<hr WIDTH="100%">
C: int CREATE_BITMAP( int Bitmap_ID, DWORD Width, DWORD Height, int Memory_Mode ) <br>  
<hr WIDTH="100%">
Euphoria Function: c_func(CREATE_BITMAP,{Bitmap_ID, Width, Height, Memory_Mode}) <br>  
<hr WIDTH="100%">
Description: Here, you can create a bitmap that you can draw graphics and/or text to. Set the Memory_Mode
parameter to 1 = created in video memory or 0 = created in software memory. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success<br> 
&nbsp; 1 = failure<p> 
</font></b></td></tr>
</table>
<br>


<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="FREE_BITMAP"></a><center><font color="Maroon">FREE_BITMAP</font></center>
<hr WIDTH="100%">
C: void FREE_BITMAP( int Bitmap_ID ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(FREE_BITMAP, {Bitmap_ID}) <br>
<hr WIDTH="100%">
Description: FREE_BITMAP will free up the memory used by the specified bitmap. You don't have to call
this routine because the EXOTICA_EXIT routine will free up any bitmaps that are currently being used.
This routine can be used to free up bitmap memory when certain bitmaps
are no longer needed in the program in which it will help keep the memory requiments for your program
lower for example.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Blit to Surface Routines:<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BLIT_BITMAP"></a><center><font color="Maroon">BLIT_BITMAP</font></center>
<hr WIDTH="100%">
C: int BLIT_BITMAP( int Bitmap_ID, LPRECT Rectanglar_Region, DWORD flags})<br>
<hr WIDTH="100%">
Euphoria Function: c_func(BLIT_BITMAP,{Bitmap_ID, Rectanglar_Region, flags})<br>
<hr WIDTH="100%">
Description: The Rectanglar_Region is the area to fill the specified bitmap with on the
backbuffer surface. Therefore, sctreching of the bitmap is easily done with this routine.
For the flags parameter, you may use  DDBLTFX_MIRRORLEFTRIGHT to mirror the image from left to right,
use DDBLTFX_MIRRORUPDOWN to mirror the image from up to down or you can OR them togethor to 
mirror the image from left to right and from up to down.<br>
<hr WIDTH="100%">
Note: you can not draw outside the screen area with this function. Also, if your video card
does not have hardware capability to blit bitmaps in DirectX using this function, this
function will be 10% slower than hardware blits.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TRANS_BLIT_BITMAP"></a><center><font color="Maroon">TRANS_BLIT_BITMAP</font></center>
<hr WIDTH="100%">
C: int TRANS_BLIT_BITMAP( int Bitmap_ID, LPRECT Rectanglar_Region, DWORD flags )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(TRANS_BLIT_BITMAP,{Bitmap_ID, Rectanglar_Region, flags})<br>
<hr WIDTH="100%">
Description: The Rectanglar_Region is the area to fill the specified bitmap with on the
backbuffer surface with transparency. Therefore, sctreching of the bitmap is easily done with this routine.
For the flags parameter, you may use  DDBLTFX_MIRRORLEFTRIGHT to mirror the image from left to right,
use DDBLTFX_MIRRORUPDOWN to mirror the image from up to down or you can OR them togethor to 
mirror the image from left to right and from up to down.<br>
<hr WIDTH="100%">
Note: you can not draw outside the screen area with this function. Also, if your video card
does not have hardware capability to blit bitmaps in DirectX using this function, this
function will be 10% slower than hardware blits.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BLITFAST"></a><center><font color="Maroon">BLITFAST</font></center>
<hr WIDTH="100%">
C: int BLITFAST( int Bitmap_ID, LONG X, LONG Y ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(BLITFAST, {Bitmap_ID, X, Y}) <br>
<hr WIDTH="100%">
Description: This routine blits a specified bitmap with no transparency. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TRANS_BLITFAST"></a><center><font color="Maroon">TRANS_BLITFAST</font></center>
<hr WIDTH="100%">
C: int TRANS_BLITFAST( int Bitmap_ID, LONG X, LONG Y ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(TRANS_BLITFAST, {Bitmap_ID, X, Y}) <br>
<hr WIDTH="100%">
Description: This routine does a transparent blit of a specified bitmap. Color Value 0 is set for transparency.
In DirectX, you can't draw outside the surface area. But these BLITFAST
routines will clip the blitted bitmaps if they are drawn outside the surface area. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="RECT_BLITFAST"></a><center><font color="Maroon">RECT_BLITFAST</font></center>
<hr WIDTH="100%">
C: int RECT_BLITFAST( int Bitmap_ID, LPRECT Rectanglar_Region, LONG X, LONG Y ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(RECT_BLITFAST,{Bitmap_ID, Rectanglar_Region, X, Y}) <br>
<hr WIDTH="100%">
Description: Copies a rectanglar region from a specified bitmap and blits it to the backbuffer with no transparency.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TRANS_RECT_BLITFAST"></a><center><font color="Maroon">TRANS_RECT_BLITFAST</font></center>
<hr WIDTH="100%">
C: int TRANS_RECT_BLITFAST( int Bitmap_ID, LPRECT Rectanglar_Region, LONG X, LONG Y ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(TRANS_RECT_BLITFAST,{Bitmap_ID, Rectanglar_Region, X, Y}) <br>
<hr WIDTH="100%">
Description: Copies a rectanglar region from a specified bitmap and blits it to the backbuffer with transparency. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Blit to Bitmap Surface Routines:<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_BLIT_BITMAP"></a><center><font color="Maroon">BITMAP_BLIT_BITMAP</font></center>
<hr WIDTH="100%">
C: int BITMAP_BLIT_BITMAP( int Bitmap_ID, LPRECT Rectanglar_Region, int Bitmap_ID_2, DWORD flags )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_BLIT_BITMAP,{Bitmap_ID, Rectanglar_Region, Bitmap_ID_2, flags})<br>
<hr WIDTH="100%">
Description: Same functionality as BLIT_BITMAP, except you will fill in an area on the 
specified Bitmap_ID_2 surface.<p>
<hr WIDTH="100%">
Note: you can not draw outside the bitmap_ID_2 area with this function. Also, if your video card
does not have hardware capability to blit bitmaps in DirectX using this function, this
function will be 10% slower than hardware blits.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TRANS_BITMAP_BLIT_BITMAP"></a><center><font color="Maroon">TRANS_BITMAP_BLIT_BITMAP</font></center>
<hr WIDTH="100%">
C: int TRANS_BITMAP_BLIT_BITMAP( int Bitmap_ID, LPRECT Rectanglar_Region, int Bitmap_ID_2, DWORD flags )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(TRANS_BITMAP_BLIT_BITMAP,{Bitmap_ID, Rectanglar_Region, Bitmap_ID_2, flags})<br>
<hr WIDTH="100%">
Description: Same functionality as TRANS_BLIT_BITMAP, except you will fill in an area on the 
specified Bitmap_ID_2 surface.<br>
<hr WIDTH="100%">
Note: you can not draw outside the bitmap_ID_2 area with this function. Also, if your video card
does not have hardware capability to blit bitmaps in DirectX using this function, this
function will be 10% slower than hardware blits.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_BLITFAST"></a><center><font color="Maroon">BITMAP_BLITFAST</font></center>
<hr WIDTH="100%">
C: int BITMAP_BLITFAST( int Bitmap_ID, int Bitmap_ID_2, LONG X, LONG Y )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_BLITFAST,{Bitmap_ID, Bitmap_ID_2, X, Y})<br>
<hr WIDTH="100%">
Description: Blits Bitmap_ID to the x,y location on Bitmap_ID_2 with no transparency.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TRANS_BITMAP_BLITFAST"></a><center><font color="Maroon">TRANS_BITMAP_BLITFAST</font></center>
<hr WIDTH="100%">
C: int TRANS_BITMAP_BLITFAST( int Bitmap_ID, int Bitmap_ID_2, LONG X, LONG Y )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(TRANS_BITMAP_BLITFAST,{Bitmap_ID, Bitmap_ID_2, X, Y})<br>
<hr WIDTH="100%">
Description: Blits Bitmap_ID to the x,y location on Bitmap_ID_2 with transparency.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="BITMAP_RECT_BLITFAST"></a><center><font color="Maroon">BITMAP_RECT_BLITFAST</font></center>
<hr WIDTH="100%">
C: int BITMAP_RECT_BLITFAST( int Bitmap_ID_1, LPRECT Rectanglar_Region, int Bitmap_ID_2, LONG X, LONG Y )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(BITMAP_RECT_BLITFAST,{Bitmap_ID_1, Rectanglar_Region, Bitmap_ID_2, X, Y})<br>
<hr WIDTH="100%">
Description: Copies a rectanglar region from then specified Bitmap_ID_1 and blits it to the specified Bitmap_ID_2 with no transparency. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="TRANS_BITMAP_RECT_BLITFAST"></a><center><font color="Maroon">TRANS_BITMAP_RECT_BLITFAST</font></center>
<hr WIDTH="100%">
C: int TRANS_BITMAP_RECT_BLITFAST( int Bitmap_ID_1, LPRECT Rectanglar_Region, int Bitmap_ID_2, LONG X, LONG Y )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(TRANS_BITMAP_RECT_BLITFAST,{Bitmap_ID_1, Rectanglar_Region, Bitmap_ID_2, X, Y})<br>
<hr WIDTH="100%">
Description: Copies a rectanglar region from then specified Bitmap_ID_1 and blits it to the specified Bitmap_ID_2 with transparency. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
GDI Text Routines:<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GDI_TEXTOUT"></a><center><font color="Maroon">GDI_TEXTOUT</font></center>
<hr WIDTH="100%">
C: int GDI_TEXTOUT( DWORD X, DWORD Y, char string[255], DWORD color, int transparency ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GDI_TEXTOUT, {X, Y, string, color, transparency}) <br>
<hr WIDTH="100%">
Description: This routine uses the WIN32's GDI Textout function to draw text on to the surface.
You can set transparent text where the background will show through by setting the
transparency parameter to 1, otherwise set to 0 for no transparency. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GDI_TEXTOUT_BITMAP"></a><center><font color="Maroon">GDI_TEXTOUT_BITMAP</font></center>
<hr WIDTH="100%">
C: int GDI_TEXTOUT_BITMAP( int Bitmap_ID, DWORD X, DWORD Y, char string[255], DWORD color, int transparency ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GDI_TEXTOUT_BITMAP, {Bitmap_ID, X, Y, string, color, transparency}) <br>
<hr WIDTH="100%">
Description: Same as GDI_TEXTOUT except this routine draws text on a specified valid Bitmap. <br>
<hr WIDTH="100%">
Return Value:<br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GDI_TEXTOUT_CENTER"></a><center><font color="Maroon">GDI_TEXTOUT_CENTER</font></center>
<hr WIDTH="100%">
C: int GDI_TEXTOUT_CENTER( DWORD X, DWORD Y, char string[255], DWORD color, int transparency ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(GDI_TEXTOUT_CENTER, {X, Y, string, color, transparency}) <br>
<hr WIDTH="100%">
Description: Same as GDI_TEXTOUT except this routine will center the text at the X, Y location. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br> 
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GDI_TEXTOUT_CENTER_BITMAP"></a><center><font color="Maroon">GDI_TEXTOUT_CENTER_BITMAP</font></center>
<hr WIDTH="100%">
Function: int GDI_TEXTOUT_CENTER_BITMAP( int Bitmap_ID, DWORD X, DWORD Y, char string[255], DWORD color, int transparency ) <br>  
<hr WIDTH="100%">
Function: c_func(GDI_TEXTOUT_CENTER_BITMAP, {Bitmap_ID, X, Y, string, color, transparency}) <br>  
<hr WIDTH="100%">
Description: Same as GDI_TEXTOUT_BITMAP except this routine will center the text at the X, Y location. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GDI_GET_CHARWIDTH"></a><center><font color="Maroon">GDI_GET_CHARWIDTH</font></center>
<hr WIDTH="100%">
C: int GDI_GET_CHARWIDTH( char text_char[1] )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(GDI_GET_CHARWIDTH,{text_char})<br>
<hr WIDTH="100%">
Description: Returns the width of a character.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="CreateFont"></a><center><font color="Maroon">
CreateFont (EUPHORIA ONLY)<br>
This was created for Euphoria Users to use<br>
</font></center>
<hr WIDTH="100%">
Euphoria Function: c_func(CreateFont,{<br>
<table BORDER =0 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
&nbsp;C_INT Height,<br>
&nbsp;C_INT Width,<br>
&nbsp;C_INT Escapement,<br>
&nbsp;C_INT Orientation,<br>
&nbsp;C_INT Weight,<br>
&nbsp;C_ULONG Italic,<br>
&nbsp;C_ULONG Underline,<br>
&nbsp;C_ULONG StrikeOut,<br>
&nbsp;C_ULONG CharSet,<br>
&nbsp;C_ULONG OutputPrecision,<br>
&nbsp;C_ULONG ClipPrecision,<br>
&nbsp;C_ULONG Quality,<br>
&nbsp;C_ULONG PitchAndFamily,<br>
&nbsp;C_POINTER lpszFace<br>
</font></b></td>
<td><b><font color="black">
-- logical height of font<br>
-- logical average character width<br>
-- angle of escapement<br>
-- base-line orientation angle<br>
-- font weight<br>
-- italic attribute flag<br>
-- underline attribute flag<br>
-- strikeout attribute flag<br>
-- character set identifier<br>
-- output precision<br>
-- clipping precision<br>
-- output quality<br>
-- pitch and family<br>
-- pointer to typeface name string<br>
</font></b></td></tr>
</table>
})<br>
<hr WIDTH="100%">
Description: This function is a Win32 function which will allow you to load and customize your font. Please, for now, check
out the <i>Hello</i> example for an example of it's use. If you have a Win32 API book of some sort, that will help you along
great for now. You are able to make as much customized fonts as you desire, memory given.
I don't plan on writting all of the create_font description here. It's to much for me to put
into this documentation and I'm to lazy to do it. You can also go to the http://www.msdn.com
website which you can find all the win32 functions descriptions. Also note that this function
is not within the Exotica Dll itself, it's defined in the ewin32api.ew file.<br>
<hr WIDTH="100%">
Return Value:<br>
&nbsp; Returns a handle to the font created<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="USE_FONT"></a><center><font color="Maroon">USE_FONT</font></center>
<hr WIDTH="100%">
C: void USE_FONT( HFONT Myfont_Handle )<br>
<hr WIDTH="100%">
Euphoria Function: c_proc(USE_FONT,{Myfont_Handle})<br>
<hr WIDTH="100%">
Description: This lovely procedure takes any atom that holds a return value from the CreateFont
routine and makes changes to any text displayed with the Win32 GDI text routines.
Please look at the <i>Hello</i> example for an example of it's use.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>

</center>
</body>
</html>
